#include "X-sok.h"
#include "bruteforce.h"

static void try_recursive(int i) {
    int x, y;
    for (y = 0; y <= arr[i].my; ++y) {
	unsigned long bitmap = 0;
	int ii;
	for (ii = 0; ii < i; ++ii)
	    if (!(arr[ii].cy >= y+arr[i].h || arr[ii].cy+arr[ii].h <= y))
		bitmap |= 1<<ii;	/* they do intersect */
	for (x = 0; x <= arr[i].mx; ++x) {
	    /* test intersection with previous rectangles */
	    for (ii = 0; ii < i; ++ii)
		if (bitmap & (1<<ii) &&
		    !(arr[ii].cx >= x+arr[i].w || arr[ii].cx+arr[ii].w <= x))
		    goto noplace;	/* they do intersect */
	    /* place tile! */
	    arr[i].cx = x; arr[i].cy = y;
	    if (i+1 >= widest+improvement) {
		widest = i+1;
		update(i+1);
	    }
	    if (i+1 == P.totaltiles) {
		/* found the solution */
		/* longjump! */
		longjmp(jbuf, 1);
	    } else
		try_recursive(i+1);
	noplace:
	    ;
	} /* for x */
    } /* for y */
}

void cmd_TryAll2(void) {
    int i;
    if (P.totaltiles > 32) {
	show_message("Only possible for <= 32 tiles");
	return;	/* due to bitmap */
    }
    for (i = 1; i <= P.totaltiles; ++i) {
	arr[i-1].w = P.t[P.position[i].tilenr].width;
	arr[i-1].h = P.t[P.position[i].tilenr].height;
	arr[i-1].mx = P.t[0].width - arr[i-1].w;
	arr[i-1].my = P.t[0].height - arr[i-1].h;
	arr[i-1].cx = arr[i-1].cy = 0;
    }
    arr[0].mx = (arr[0].mx+1) / 2;
    arr[0].my = (arr[0].my+1) / 2;
    widest = 0;
    if (!setjmp(jbuf))
	try_recursive(0);
    show_message("%d tiles placed", widest);
}
